package org.ros.chatto.dto;

import javax.persistence.Transient;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import lombok.Data;

@Data
public class UserRegistrationDTO {
	@Size(min = 4, max = 10, message = "Username must be between 4 and 10 characters")
	@NotBlank(message = "Username should not be blank")
	@Pattern(regexp = "^[A-Za-z0-9]+$", message = "Username must be alphanumeric")
	private String userName;
	@Transient
	@Size(min = 4, max = 75, message = "Password must be between 4 and 75  characters")
	@NotBlank(message = "Password should not be blank")
//	@Pattern(regexp = "^.*(?=.{6,})(?=.*d)(?=.*[A-Z])(?=.*[a-z])(?=.*[!@#$%^&*? ]).*$", message = "Invalid password format")
	private String password;
	
	private Long captchaID;
	private String captchaText;
	
	private String captchaInput;
}
